

function love.load()

	-- SHORTCUTS

	lg = love.graphics
	WIDTH, HEIGHT = love.window.getDimensions()


	-- INIT BOXES

	box = {}

	box[1] = {x=2,y=2,w=60,h=60,xvel=80,yvel=180,overlap=false}
	box[2] = {x=WIDTH - 62,y=2,w=60,h=60,xvel=100,yvel=120,overlap=false}
	box[3] = {x=2,y=HEIGHT - 62,w=60,h=60,xvel=40,yvel=50,overlap=false}
	box[4] = {x=WIDTH - 62,y=HEIGHT-62,w=60,h=60,xvel=120,yvel=90,overlap=false}

end


---------- UPDATE ----------

function love.update(dt)

	for i = 1, #box do 
		moveBox(box[i],dt)
	end

	for i=1,#box-1 do
		
		for j=i+1,#box do

			if box[i] ~= box[j] then

				if checkCollision(box[i],box[j]) then
					box[i].overlap = true
					box[j].overlap = true
				else
					box[i].overlap = false
					box[j].overlap = false
				end
			end
		end
	end

end


---------- DRAW ----------

function love.draw()
	
	for i, box in ipairs(box) do
		if box.overlap then
			lg.setColor(255,2,2)
		else
			lg.setColor(255,255,255)
		end
		lg.rectangle("fill",box.x, box.y, box.w, box.h)
		lg.setColor(255,2,2)
		lg.print(i, box.x+box.w/2,box.y+box.h/2)
		lg.setColor(255,255,255)
	end

end


---------- KEYPRESSED ----------

function love.keypressed(k)
	
	if k == "escape" then love.event.quit() end

end


---------- MOVE BOX ----------

function moveBox(self,dt)
		
		self.x = self.x + self.xvel * dt
		self.y = self.y + self.yvel * dt

		if self.x+self.w > WIDTH or self.x < 0 then
			self.xvel =  -self.xvel  
		end

		if self.y+self.h > HEIGHT or self.y < 0 then
			self.yvel =  -self.yvel  
		end
end


---------- CHECK COLLISION ----------

function checkCollision(a, b)
	
	return a.x < b.x + b.w
	and b.x < a.x + a.w
	and a.y < b.y + b.h
	and b.y < a.h + a.h

end